<template>
	<AppPage>
		<b-card
			title="Add a development or master course, which does not exist in MaineStreet"
		>
			<b-card-body
				v-if="!hasPermission('post:lmsCourse-dev')"
				body-bg-variant="danger"
			>
				You do not have permission to add a development or master course
			</b-card-body>
			<b-card-body v-if="hasPermission('post:lmsCourse-dev')">
				<div>
					<MasterCourseSelector v-model="course.master" class="mb-3" />

					<b-form class="mx-auto w-50">
						<b-form-group
							id="frmCode"
							label="Course Code"
							label-for="txtCode"
							description="Prefixes:  CRS, DEP, DEV, NCC, ORG, PRA"
						>
							<b-form-input
								id="txtCode"
								v-model="course.code"
								:state="course_code_state"
								required
								placeholder="Course Code"
							></b-form-input>
							<b-form-invalid-feedback
								>Course Code already submitted, enter a new one
							</b-form-invalid-feedback>
						</b-form-group>
						<b-form-group
							id="frmTitle"
							label="Course Title"
							label-for="txtTitle"
							description=""
						>
							<b-form-input
								id="txtTitle"
								v-model="course.title"
								required
								placeholder="Course Title"
							></b-form-input>
						</b-form-group>
						<div class="btn-toolbar" role="toolbar">
							<div id="btnAddDevCourse">
								<b-button
									type="submit"
									variant="primary"
									:disabled="submit_disabled"
									class="mr-2"
									@click="add_dev_course"
									>Add Development Course
								</b-button>
							</div>
							<AdminHelpTooltip
								target="btnAddDevCourse"
								permissions="post:lmsCourse-dev"
							/>
							<div id="btnAddMasterCourse">
								<b-button
									id="btnAddMasterCourse"
									type="submit"
									variant="primary"
									:disabled="submit_disabled"
									@click="add_master_course"
									>Add Master Course
								</b-button>
							</div>
							<AdminHelpTooltip
								target="btnAddMasterCourse"
								permissions="post:lmsCourse-dev"
							/>
						</div>
					</b-form>
				</div>
			</b-card-body>
		</b-card>
	</AppPage>
</template>

<script>
import { mapGetters, mapActions } from "vuex";

export default {
	data() {
		return {
			course: {
				code: "",
				title: "",
				master: null
			},
			submitted_course_codes: []
		};
	},
	computed: {
		...mapGetters({hasPermission: "Navbar/hasPermission"}),
		course_code_state() {
			if (this.course.code.length === 0) {
				return null;
			}

			return !this.submitted_course_codes.includes(this.course.code);
		},
		master_course_valid() {
			return this.course.master === null || this.course.master.length > 0;
		},
		submit_disabled() {
			return !this.course_code_state || !this.master_course_valid;
		}
	},
	methods: {
		...mapActions({create_dev_course: "MasterCourseSelector/create_dev_course"}),
		add_course(isMaster) {
			if (this.hasPermission("post:lmsCourse-dev")) {
				this.submitted_course_codes.push(this.course.code);

				let data = {
					code: this.course.code,
					name: this.course.title,
					isMaster: isMaster
				};
				if (this.course.master && this.course.master.length > 0) {
					data.master = this.course.master;
				}

				this.create_dev_course(data);

				this.course.code = "";
			}
		},
		add_dev_course() {
			this.add_course(false);
		},
		add_master_course() {
			this.add_course(true);
		}
	}
};
</script>
